local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	x.TimeToDie = s.TimeToDie("target") or 10
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown() + x.Lag
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.ActiveEnemies = a.ActiveEnemies()
	x.Haste = 1 + UnitSpellHaste("player")/100
	x.MaxGCD = 1.5 / x.Haste
	x.ManaPercent = s.PowerPercent("player", SPELL_POWER_MANA)
	x.SoulShards = s.Power("player", SPELL_POWER_SOUL_SHARDS)
	
	if x.Spec == 1 then
		-- Affliction
--[[
-- Executed every time the actor is available.
,"call_action_list,name=mg,if=talent.malefic_grasp.enabled"
,"call_action_list,name=writhe,if=talent.writhe_in_agony.enabled"
,"call_action_list,name=haunt,if=talent.haunt.enabled"

-- Haunt
,"reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.tormented_souls.react>=5|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
,"reap_souls,if=debuff.haunt.remains&!buff.deadwind_harvester.remains"
,"reap_souls,if=active_enemies>1&!buff.deadwind_harvester.remains&time>5&soul_shard>0&((talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|spell_targets.seed_of_corruption>=5)"
,"agony,cycle_targets=1,if=remains<=tick_time+gcd"
,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
,"service_pet,if=dot.corruption.remains&dot.agony.remains"
,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
,"blood_fury"
,"soul_harvest,if=buff.soul_harvest.remains<=8&buff.active_uas.stack>=1&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)"
,"potion,if=!talent.soul_harvest.enabled&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|buff.active_uas.stack>2)"
,"potion,if=talent.soul_harvest.enabled&buff.soul_harvest.remains&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|!cooldown.haunt.remains|buff.active_uas.stack>2)"
,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd"
,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&(spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<5)"
,"reap_souls,if=(buff.deadwind_harvester.remains+buff.tormented_souls.react*(5+equipped.144364))>=(12*(5+1.5*equipped.144364))"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
,"phantom_singularity"
,"haunt"
,"agony,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3|talent.malefic_grasp.enabled&target.time_to_die>15&mana.pct<10"
,"siphon_life,if=remains<=duration*0.3&target.time_to_die>=remains"
,"siphon_life,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"
,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3|spell_targets.seed_of_corruption>=5|spell_targets.seed_of_corruption>=3&dot.corruption.remains<=cast_time+travel_time"
,"corruption,if=remains<=duration*0.3&target.time_to_die>=remains"
,"corruption,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"
,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&((soul_shard>=4&!talent.contagion.enabled)|soul_shard>=5|target.time_to_die<30)"
,"unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&soul_shard>=4&talent.contagion.enabled&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&(equipped.132381|equipped.132457)&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&talent.contagion.enabled&soul_shard>=4&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*2"
,"reap_souls,if=!buff.deadwind_harvester.remains&(buff.active_uas.stack>1|(prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1))"
,"life_tap,if=mana.pct<=10"
,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
,"drain_soul,chain=1,interrupt=1"
,"life_tap,moving=1,if=mana.pct<80"
,"agony,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"life_tap,moving=0"

-- Malefic Grasp
,"reap_souls,if=!buff.deadwind_harvester.remains&time>5&((buff.tormented_souls.react>=4+active_enemies|buff.tormented_souls.react>=9)|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
,"agony,cycle_targets=1,max_cycle_targets=5,target_if=sim.target!=target&talent.soul_harvest.enabled&cooldown.soul_harvest.remains<cast_time*6&remains<=duration*0.3&target.time_to_die>=remains&time_to_die>tick_time*3"
,"agony,cycle_targets=1,max_cycle_targets=4,if=remains<=(tick_time+gcd)"
,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3&soul_shard=5"
,"unstable_affliction,if=target=sim.target&soul_shard=5"
,"drain_soul,cycle_targets=1,if=target.time_to_die<gcd*2&soul_shard<5"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
,"service_pet,if=dot.corruption.remains&dot.agony.remains"
,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
,"blood_fury"
,"siphon_life,cycle_targets=1,if=remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"
,"corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"
,"phantom_singularity"
,"soul_harvest,if=buff.active_uas.stack>1&buff.soul_harvest.remains<=8&sim.target=target&(!talent.deaths_embrace.enabled|target.time_to_die>=136|target.time_to_die<=40)"
,"potion,if=target.time_to_die<=70"
,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&buff.active_uas.stack>=2"
,"agony,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.agony)"
,"siphon_life,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.siphon_life)"
,"corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.corruption)"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3|talent.malefic_grasp.enabled&target.time_to_die>15&mana.pct<10"
,"seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>=5&dot.corruption.remains<=cast_time+travel_time)"
,"unstable_affliction,if=target=sim.target&target.time_to_die<30"
,"unstable_affliction,if=target=sim.target&active_enemies>1&soul_shard>=4"
,"unstable_affliction,if=target=sim.target&(buff.active_uas.stack=0|(!prev_gcd.3.unstable_affliction&prev_gcd.1.unstable_affliction))&dot.agony.remains>cast_time+(6.5*spell_haste)"
,"reap_souls,if=buff.deadwind_harvester.remains<dot.unstable_affliction_1.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_2.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_3.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_4.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_5.remains&buff.active_uas.stack>1"
,"life_tap,if=mana.pct<=10"
,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
,"drain_soul,chain=1,interrupt=1"
,"life_tap,moving=1,if=mana.pct<80"
,"agony,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
,"siphon_life,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
,"corruption,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
,"life_tap,moving=0"

-- Writhe
,"reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.tormented_souls.react>=5|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
,"reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.soul_harvest.remains>=(5+1.5*equipped.144364)&buff.active_uas.stack>1|buff.concordance_of_the_legionfall.react|trinket.proc.intellect.react|trinket.stacking_proc.intellect.react|trinket.proc.mastery.react|trinket.stacking_proc.mastery.react|trinket.proc.crit.react|trinket.stacking_proc.crit.react|trinket.proc.versatility.react|trinket.stacking_proc.versatility.react|trinket.proc.spell_power.react|trinket.stacking_proc.spell_power.react)"
,"agony,if=remains<=tick_time+gcd"
,"agony,cycle_targets=1,max_cycle_targets=5,target_if=sim.target!=target&talent.soul_harvest.enabled&cooldown.soul_harvest.remains<cast_time*6&remains<=duration*0.3&target.time_to_die>=remains&time_to_die>tick_time*3"
,"agony,cycle_targets=1,max_cycle_targets=3,target_if=sim.target!=target&remains<=tick_time+gcd&time_to_die>tick_time*3"
,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3&soul_shard=5"
,"unstable_affliction,if=soul_shard=5|(time_to_die<=((duration+cast_time)*soul_shard))"
,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
,"service_pet,if=dot.corruption.remains&dot.agony.remains"
,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
,"blood_fury"
,"soul_harvest,if=sim.target=target&buff.soul_harvest.remains<=8&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)&(buff.active_uas.stack>=2|active_enemies>3)&(!talent.deaths_embrace.enabled|time_to_die>120|time_to_die<30)"
,"potion,if=target.time_to_die<=70"
,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&(trinket.proc.any.react|trinket.stack_proc.any.react|buff.active_uas.stack>=2)"
,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd&time_to_die>tick_time*2"
,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&((spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled)|spell_targets.seed_of_corruption<5)&time_to_die>tick_time*2"
,"life_tap,if=mana.pct<40&(buff.active_uas.stack<1|!buff.deadwind_harvester.remains)"
,"reap_souls,if=(buff.deadwind_harvester.remains+buff.tormented_souls.react*(5+equipped.144364))>=(12*(5+1.5*equipped.144364))"
,"phantom_singularity"
,"seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>3&dot.corruption.refreshable)"
,"unstable_affliction,if=talent.contagion.enabled&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=talent.absolute_corruption.enabled&set_bonus.tier21_4pc&debuff.tormented_agony.remains<=cast_time"
,"unstable_affliction,cycle_targets=1,target_if=buff.deadwind_harvester.remains>=duration+cast_time&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=buff.deadwind_harvester.remains>tick_time*2&(!set_bonus.tier21_4pc|talent.contagion.enabled|soul_shard>1)&(!talent.contagion.enabled|soul_shard>1|buff.soul_harvest.remains)&(dot.unstable_affliction_1.ticking+dot.unstable_affliction_2.ticking+dot.unstable_affliction_3.ticking+dot.unstable_affliction_4.ticking+dot.unstable_affliction_5.ticking<5)"
,"reap_souls,if=!buff.deadwind_harvester.remains&buff.active_uas.stack>1"
,"reap_souls,if=!buff.deadwind_harvester.remains&prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3&(!buff.deadwind_harvester.remains|buff.active_uas.stack<1)"
,"agony,if=refreshable&time_to_die>=remains"
,"siphon_life,if=refreshable&time_to_die>=remains"
,"corruption,if=refreshable&time_to_die>=remains"
,"agony,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
,"siphon_life,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
,"corruption,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
,"life_tap,if=mana.pct<=10"
,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
,"drain_soul,chain=1,interrupt=1"
,"life_tap,moving=1,if=mana.pct<80"
,"agony,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"life_tap,moving=0"
]]
	elseif x.Spec == 2 then
		-- Demonology

		x.three_min = a.doomguard_no_de() > 0 or a.infernal_no_de() > 0
		x.no_de1 = a.dreadstalker_no_de() > 0 or a.darkglare_no_de() > 0 or a.doomguard_no_de() > 0 or a.infernal_no_de() > 0 or a.service_no_de() > 0
		x.no_de2 = (x.three_min and a.service_no_de() > 0) or (x.three_min and a.wild_imp_no_de() > 0) or (x.three_min and a.dreadstalker_no_de() > 0) or (a.service_no_de() > 0 and a.dreadstalker_no_de() > 0) or (a.service_no_de() > 0 and a.wild_imp_no_de() > 0) or (a.dreadstalker_no_de() > 0 and a.wild_imp_no_de() > 0) or (s.Casting(105174--[[Hand of Gul'dan]], "player") and x.no_de1)
		if s.Casting(686--[[Shadow Bolt]], "player") then
			x.SoulShards = math.min(5, x.SoulShards + 1)
		end
		x.TalentImplosionEnabled = s.HasTalent(196277--[[Implosion]])
		x.TalentPowerTripEnabled = s.HasTalent(196605--[[Power Trip]])
		x.TalentDemonboltEnabled = s.HasTalent(157695--[[Demonbolt]])
		x.TalentSupremacyEnabled = s.HasTalent(152107--[[Grimoire of Supremacy]])
		x.TalentDarkglareEnabled = s.HasTalent(205180--[[Summon Darkglare]])
		x.TalentShadowyInspirationEnabled = s.HasTalent(196269--[[Shadowy Inspiration]])
		x.TalentSoulConduitEnabled = s.HasTalent(215941--[[Soul Conduit]])
		
		x.BuffDemonicCallingRemains = s.BuffDuration(205146--[[Demonic Calling]], "player")
		x.BuffDemonicSynergyRemains = s.BuffDuration(171982--[[Demonic Synergy]], "player")
		x.DebuffDoomRemains = s.MyDebuffDuration(603--[[Doom]], "target")
		x.DoomDuration = 20/x.Haste
		x.CooldownSummonDarkglareRemains = s.SpellCooldown(205180--[[Summon Darkglare]])
		x.CooldownCallDreadstalkers = s.SpellCooldown(104316--[[Call Dreadstalkers]])
		x.PrevGCDHandOfGuldan = s.Casting(105174--[[Hand of Gul'dan]], "player")
		x.CanCastDreadstalkers = not s.Casting(104316--[[Call Dreeadstalkers]], "player") and (x.SoulShards >= 2 or s.BuffDuration(205146--[[Demonic Calling]], "player") >= x.GCD)

		a.Flash("auto_attack"
				,"implosion,if=wild_imp_remaining_duration<=action.shadow_bolt.execute_time&(buff.demonic_synergy.remains|talent.soul_conduit.enabled|(!talent.soul_conduit.enabled&spell_targets.implosion>1)|wild_imp_count<=4)"
				,"implosion,if=prev_gcd.1.hand_of_guldan&((wild_imp_remaining_duration<=3&buff.demonic_synergy.remains)|(wild_imp_remaining_duration<=4&spell_targets.implosion>2))"
--				,"shadowflame,if=(debuff.shadowflame.stack>0&remains<action.shadow_bolt.cast_time+travel_time)&spell_targets.demonwrath<5"
--				,"summon_infernal,if=(!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening>2)&equipped.132369"
--				,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening<=2&equipped.132369"
				,"call_dreadstalkers,if=((!talent.summon_darkglare.enabled|talent.power_trip.enabled)&(spell_targets.implosion<3|!talent.implosion.enabled))&!(soul_shard=5&buff.demonic_calling.remains)"
				,"doom,cycle_targets=1,if=(!talent.hand_of_doom.enabled&target.time_to_die>duration&(!ticking|remains<duration*0.3))&!(variable.no_de1|prev_gcd.1.hand_of_guldan)"
--				,"shadowflame,if=(charges=2&soul_shard<5)&spell_targets.demonwrath<5&!variable.no_de1"
				,"service_pet"
				,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
				,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening>2"
--				,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
--				,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
				,"shadow_bolt,if=buff.shadowy_inspiration.remains&soul_shard<5&!prev_gcd.1.doom&!variable.no_de2"
--				,"summon_darkglare,if=prev_gcd.1.hand_of_guldan|prev_gcd.1.call_dreadstalkers|talent.power_trip.enabled"
--				,"summon_darkglare,if=cooldown.call_dreadstalkers.remains>5&soul_shard<3"
--				,"summon_darkglare,if=cooldown.call_dreadstalkers.remains<=action.summon_darkglare.cast_time&(soul_shard>=3|soul_shard>=1&buff.demonic_calling.react)"
				,"call_dreadstalkers,if=talent.summon_darkglare.enabled&(spell_targets.implosion<3|!talent.implosion.enabled)&(cooldown.summon_darkglare.remains>2|prev_gcd.1.summon_darkglare|cooldown.summon_darkglare.remains<=action.call_dreadstalkers.cast_time&soul_shard>=3|cooldown.summon_darkglare.remains<=action.call_dreadstalkers.cast_time&soul_shard>=1&buff.demonic_calling.react)"
				,"hand_of_guldan,if=soul_shard>=4&(((!(variable.no_de1|prev_gcd.1.hand_of_guldan)&(pet_count>=13&!talent.shadowy_inspiration.enabled|pet_count>=6&talent.shadowy_inspiration.enabled))|!variable.no_de2|soul_shard=5)&talent.power_trip.enabled)"
				,"hand_of_guldan,if=(soul_shard>=3&prev_gcd.1.call_dreadstalkers&!artifact.thalkiels_ascendance.rank)|soul_shard>=5|(soul_shard>=4&cooldown.summon_darkglare.remains>2)"
				,"demonic_empowerment,if=(((talent.power_trip.enabled&(!talent.implosion.enabled|spell_targets.demonwrath<=1))|!talent.implosion.enabled|(talent.implosion.enabled&!talent.soul_conduit.enabled&spell_targets.demonwrath<=3))&(wild_imp_no_de>3|prev_gcd.1.hand_of_guldan))|(prev_gcd.1.hand_of_guldan&wild_imp_no_de=0&wild_imp_remaining_duration<=0)|(prev_gcd.1.implosion&wild_imp_no_de>0)"
				,"demonic_empowerment,if=variable.no_de1|prev_gcd.1.hand_of_guldan"
--				,"use_items"
				,"berserking"
--				,"blood_fury"
				,"soul_harvest,if=!buff.soul_harvest.remains"
--				,"potion,name=prolonged_power,if=buff.soul_harvest.remains|target.time_to_die<=70|trinket.proc.any.react"
--				,"shadowflame,if=charges=2&spell_targets.demonwrath<5"
				,"thalkiels_consumption,if=(dreadstalker_remaining_duration>execute_time|talent.implosion.enabled&spell_targets.implosion>=3)&(wild_imp_count>3&dreadstalker_count<=2|wild_imp_count>5)&wild_imp_remaining_duration>execute_time"
				,"felstorm"
				,"life_tap,if=mana.pct<=15|(mana.pct<=65&((cooldown.call_dreadstalkers.remains<=0.75&soul_shard>=2)|((cooldown.call_dreadstalkers.remains<gcd*2)&(cooldown.summon_doomguard.remains<=0.75|cooldown.service_pet.remains<=0.75)&soul_shard>=3)))"
				,"demonwrath,chain=1,interrupt=1,if=spell_targets.demonwrath>=3"
				,"demonwrath,moving=1,chain=1,interrupt=1"
				,"demonbolt"
				,"shadow_bolt,if=buff.shadowy_inspiration.remains"
				,"demonic_empowerment,if=artifact.thalkiels_ascendance.rank&talent.power_trip.enabled&!talent.demonbolt.enabled&talent.shadowy_inspiration.enabled"
				,"shadow_bolt"
				,"life_tap"
				)
	else
		-- Destruction
--[[
-- Executed every time the actor is available.
,"immolate,cycle_targets=1,if=active_enemies=2&talent.roaring_blaze.enabled&!cooldown.havoc.remains&dot.immolate.remains<=buff.active_havoc.duration"
,"havoc,target=2,if=active_enemies>1&(active_enemies<4|talent.wreak_havoc.enabled&active_enemies<6)&!debuff.havoc.remains"
,"dimensional_rift,if=charges=3"
,"cataclysm,if=spell_targets.cataclysm>=3"
,"immolate,if=(active_enemies<5|!talent.fire_and_brimstone.enabled)&remains<=tick_time"
,"immolate,cycle_targets=1,if=(active_enemies<5|!talent.fire_and_brimstone.enabled)&(!talent.cataclysm.enabled|cooldown.cataclysm.remains>=action.immolate.cast_time*active_enemies)&active_enemies>1&remains<=tick_time&(!talent.roaring_blaze.enabled|(!debuff.roaring_blaze.remains&action.conflagrate.charges<2+set_bonus.tier19_4pc))"
,"immolate,if=talent.roaring_blaze.enabled&remains<=duration&!debuff.roaring_blaze.remains&target.time_to_die>10&(action.conflagrate.charges=2+set_bonus.tier19_4pc|(action.conflagrate.charges>=1+set_bonus.tier19_4pc&action.conflagrate.recharge_time<cast_time+gcd)|target.time_to_die<24)"
,"berserking"
,"blood_fury"
,"use_items"
,"potion,if=(buff.soul_harvest.remains|trinket.proc.any.react|target.time_to_die<=45)"
,"shadowburn,if=soul_shard<4&buff.conflagration_of_chaos.remains<=action.chaos_bolt.cast_time"
,"shadowburn,if=(charges=1+set_bonus.tier19_4pc&recharge_time<action.chaos_bolt.cast_time|charges=2+set_bonus.tier19_4pc)&soul_shard<5"
,"conflagrate,if=talent.roaring_blaze.enabled&(charges=2+set_bonus.tier19_4pc|(charges>=1+set_bonus.tier19_4pc&recharge_time<gcd)|target.time_to_die<24)"
,"conflagrate,if=talent.roaring_blaze.enabled&debuff.roaring_blaze.stack>0&dot.immolate.remains>dot.immolate.duration*0.3&(active_enemies=1|soul_shard<3)&soul_shard<5"
,"conflagrate,if=!talent.roaring_blaze.enabled&buff.backdraft.stack<3&(charges=1+set_bonus.tier19_4pc&recharge_time<action.chaos_bolt.cast_time|charges=2+set_bonus.tier19_4pc)&soul_shard<5"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
,"dimensional_rift,if=equipped.144369&!buff.lessons_of_spacetime.remains&(buff.soul_harvest.remains|pet.service_imp.active|!talent.grimoire_of_supremacy.enabled&(pet.doomguard.active|pet.infernal.active))"
,"service_pet"
,"summon_infernal,if=artifact.lord_of_flames.rank>0&!buff.lord_of_flames.remains"
,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.infernal_awakening>2"
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&artifact.lord_of_flames.rank>0&buff.lord_of_flames.remains&!pet.doomguard.active"
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"soul_harvest,if=!buff.soul_harvest.remains"
,"chaos_bolt,if=active_enemies<4&buff.active_havoc.remains>cast_time"
,"channel_demonfire,if=dot.immolate.remains>cast_time&(active_enemies=1|buff.active_havoc.remains<action.chaos_bolt.cast_time)"
,"rain_of_fire,if=active_enemies>=3"
,"rain_of_fire,if=active_enemies>=6&talent.wreak_havoc.enabled"
,"dimensional_rift,if=target.time_to_die<=32|!equipped.144369|charges>1|(!equipped.144369&(!talent.grimoire_of_service.enabled|recharge_time<cooldown.service_pet.remains)&(!talent.soul_harvest.enabled|recharge_time<cooldown.soul_harvest.remains)&(!talent.grimoire_of_supremacy.enabled|recharge_time<cooldown.summon_doomguard.remains))"
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3"
,"cataclysm"
,"chaos_bolt,if=active_enemies<3&(cooldown.havoc.remains>12&cooldown.havoc.remains|active_enemies=1|soul_shard>=5-spell_targets.infernal_awakening*1.5|target.time_to_die<=10)"
,"shadowburn"
,"conflagrate,if=!talent.roaring_blaze.enabled&buff.backdraft.stack<3"
,"immolate,cycle_targets=1,if=(active_enemies<5|!talent.fire_and_brimstone.enabled)&(!talent.cataclysm.enabled|cooldown.cataclysm.remains>=action.immolate.cast_time*active_enemies)&!talent.roaring_blaze.enabled&remains<=duration*0.3"
,"incinerate"
,"life_tap"
]]
	end
	
end)
